%
% Model functions
% The IRIS Toolbox 2007/01/29
%
% ACF                  Autocovariance and autocorrelation function.
% ALTERNATIVE          Select subset of model parameterizations and respective solutions.
% ASSIGN               Assign parameters and/or steady states.
% ASSIGNMATCH          Assign model parameters and/or steady state matching names with regular expressions.
% CHKSSTATE            Evaluate model equations with currently assigned steady state.
% DB2DPACK             Datapack for model simulation or filtering.
% DP2DBASE             Datapack to database converstion (cell array to struct).
% EIG                  Model eigenvalues sorted in ascending order of moduli.
% EMPTYDB              Create empty database(s) for model. 
% EVAL                 Use database to evaluate model equations and compute 1st-order accurate residuals.
% EXPAND               Forward expansion of model solution to t+k.
% FEVD                 Forecast error variance decomposition.
% FFRF                 Frequency response function of state-space filter.
% FMSE                 Forecast mean square error.
% FPRINTF              Write formatted model data to file.
% GET                  Get attributes of model.
% HARDCOND             Impose hard conditions on simulation.
% IFRF                 Frequency response function to input signals.
% ISLINEAR             True if model has been declared as linear.
% ISNAN                Check for presence of NaNs is assigned parameters or steady state.
% ISSTATIONARY         True if there are no unit roots in model transition matrix.
% KALMANF              Kalman filter.
% LOGLIK               Evaluate log-likelihood and project state vector using Kalman filter.
% LOGLIKDERIV          Gradient and Hessian of log-likelihood function.
% MAXLOGLIK            Maximum likelihood estimation.
% MISSING              Check source database or datapack for missing initial conditions.
% MODEL                Read in model code file and create new model object.
% OUTSIDE              Evaluate @outside equations.
% RESAMPLE             Simulate model drawing from shock distribution.
% SET                  Set attributes of model.
% SIMULATE             Simulate model.
% SOLVE                Compute 1st-order accurate model solution (i.e. policy function).
% SPRINTF              Write formatted model data to string.
% SRF                  Shock (impulse) response function (VMA representation).
% SSPACE               Quasi-triangular state-space form of model.
% SSTATE               Compute steady state of model (and solve model if linear).
% SSTATEDB             Steady-state source database for model.
% XSF                  Power spectrum and spectral density function.
% ZERODB               Zero source database for model. 
% ZERODP               Zero source datapack for model. 
