function [flag,list] = isnan(m,varargin)
%
% ISNAN  Check for presence of NaNs is assigned parameters or steady state.
%
% [flag,list] = isnan(m)
% [flag,list] = isnan(m,'parameters')
% [flag,list] = isnan(m,'sstate')
% Arguments:
%   flag logical, list cellstr, m model
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

tmp = any(isnan(m.assign),3);
if nargin == 1
  index = tmp & m.nametype <= 4;
else
  switch strtrim(lower(varargin{1}))
  case {'p','parameters'}
    index = tmp & m.nametype == 4;
    if nargout > 1, list = m.name(index); end
  case {'sstate'}
    index = tmp & m.nametype <= 3;
    if nargout > 1, list = m.name(index); end
  case {'solution'}
    index = vech(any(any(isnan(m.solution{1}),1),2));
    if nargout > 1, list = index; end
  otherwise
    error('Incorrect input argument: %s.',varargin{1});
  end
end
flag = any(index);

end % of primary function -----------------------------------------------------------------------------------