function evaluate = evaldp_(m,rundp,xb,sstatedp,select)
%
% PRIVATE/EVALDP_  Evaluate inaccuracy of equations.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

[ny,nx,nf,nb,ne,np] = dim_(m);
nper = length(rundp{4});

evaluate = cell([1,2]);
evaluate{1} = nan([sum(m.eqtntype == 1),nper]);
evaluate{2} = nan([sum(m.eqtntype == 2),nper]);
if ~any([select{:}]), return, end

tmax = max(imag([m.solutionid{:}]));
tmin = min(imag([m.solutionid{:}])) - 1;
tzero = 1 - tmin;

dpack{1} = rundp{1};
if ~isempty(xb), dpack{2} = [rundp{2}(1:nf,:);xb]; end
dpack{3} = rundp{3};
if ~isempty(sstatedp)
  dpack{1} = dpack{1} + sstatedp{1};
  dpack{2} = dpack{2} + sstatedp{2};
end

x = nan([nper,sum(m.nametype <= 4),tmax-tmin+1]);

x(:,m.nametype == 1,tzero) = transpose(dpack{1});
x(:,m.nametype == 3,tzero) = transpose(dpack{3});
x(:,m.nametype == 4,tzero) = ref(m.assign(m.nametype == 4),ones([1,nper]),1:np);

id = m.solutionid{2};
for i = find(m.nametype == 2)
  index = find(real(id) == i);
  x(:,i,tzero+imag(id(index))) = permute(dpack{2}(index,:),[2,3,1]);
  x(2:end,i,tzero+imag(id(index(end)))-1) = permute(dpack{2}(index(end),1:end-1),[2,3,1]);
end
x(:,m.log,:) = exp(x(:,m.log,:));

t = tzero;
for i = find(select{1})
  evaluate{1}(i,:)  = transpose(eval(m.eqtnF{i}));
end
for i = find(select{2})
  evaluate{2}(i,:)  = transpose(eval(m.eqtnF{ny+i}));
end

end % of primary function -----------------------------------------------------------------------------------