function [solution,expand] = expand_(solution,expand,k)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

nx = size(solution{1},1); % number of transition variables
ne = size(solution{2},2); % number of residuals
nalt = size(solution{1},3); % number of alternatives

R = solution{2};
k0 = size(R,2)/ne - 1; % expansion up to t+k0 available
if k0 >= k, warning_(23,{k0}); return, end % expansion already available

R(:,end+(1:ne*(k-k0)),1:nalt) = NaN;

for ialt = 1 : nalt
  Xa = expand{1}(:,:,ialt);
  Xf = expand{2}(:,:,ialt);
  Ru = expand{3}(:,:,ialt);
  J = expand{4}(:,:,ialt);
  Jk = expand{5}(:,:,ialt);
  for i = k0+1 : k
    Ra = -Xa*Jk*Ru; % Jk stores J^(k-1)
    Jk = Jk*J;
    Rf = Xf*Jk*Ru;
    R(:,i*ne+(1:ne),ialt) = [Rf;Ra];
  end
  expand{5}(:,:,ialt) = Jk;
end
solution{2} = R;

end % of primary function -----------------------------------------------------------------------------------