function [RU,HV,factors,fast] = factor_(solution,anticipate,residix,exogix,endogix,fast)
%
% MODEL/PRIVATE/FACTOR_  Compute residual filters and their LU factorization.

% function body ---------------------------------------------------------------------------------------------

T = solution{1};
R = solution{2};
K = solution{3};
Z = solution{4};
H = solution{5};
D = solution{6};
Za = solution{7};
U = solution{8};
V = solution{9};

ny = size(Z,1);
[nx,nb] = size(T);
nf = nx - nb;
[nt,ne] = size(U);

lastresid = find(any([residix{3}(:,2:end);endogix{3}(:,2:end)],1),1,'last');
lastexog = find(any([exogix{1}(:,2:end);exogix{2}(:,2:end)],1),1,'last');
factors = {[],[]};

HV = H*V;  
RU = R(:,1:nt)*U;
if anticipate == true
  RU = [RU,zeros([nx,ne*(lastresid-1)])];
  for k = 2 : lastresid, RU(:,ne*(k-1)+(1:ne)) = R(:,nt*(k-1)+(1:nt))*U; end
end

nexog = sum(sum([exogix{1}(:,2:end);exogix{2}(:,2:end)]));
nendog = sum(endogix{2}(:,1)) + sum(sum(endogix{3}(:,2:end)));
if nexog == 0 && nendog == 0, fast = false; return, end

% fast e/e system 
if fast == true && anticipate == false && nexog == nendog && ~any(endogix{2}(:))
  return
end
fast = false;

endogix_ = [vech(endogix{3}(:,2:end)),vech(endogix{2}(:,1))];
ninit = sum(endogix{2}(:,1));
if anticipate == true
  D = [RU,T];
  C = Z*D(nf+1:end,:);
else
  D = [RU,zeros([nx,(lastresid-1)*ne]),T];
  C = [Z*D(nf+1:end,1:ne),zeros([ny,(lastresid-1)*ne]),Z*T(nf+1:end,:)];
end
C(:,1:ne) = C(:,1:ne) + HV;
D0 = D;
index = find(any(D,1));
M = zeros([nexog,nendog]);
t = 1;
last = 0;
setup_();
for t = 2 : lastexog
  index = find(any(D,1));
  D(:,index) = T*D(nf+1:end,index);
  D(:,(t-1)*ne+1:end-ninit) = D(:,(t-1)*ne+1:end-ninit) + D0(:,1:end-ninit-(t-1)*ne);
  index = find(any(D,1));
  C(:,index) = Z*D(nf+1:end,index);
  C(:,(t-1)*ne+(1:ne)) = C(:,(t-1)*ne+(1:ne)) + HV;
  setup_();
end
[factors{1:2}] = lu(M);

  function DD = dtransform_(k) % nested function ------------------------------------------------------------
  
  DD = D;
  DD(nf+1:end,index) = Za*DD(nf+1:end,index);
  DD = DD(exogix{2}(:,k),endogix_);

  end % of nested function ----------------------------------------------------------------------------------

  function setup_()
  n = sum(exogix{1}(:,t+1));
  M(last+(1:n),:) = C(exogix{1}(:,t+1),endogix_);
  last = last + n;
  n = sum(exogix{2}(:,t+1));
  M(last+(1:n),:) = dtransform_(t+1);
  last = last + n;
  end

end % of primary function -----------------------------------------------------------------------------------