function m = meta_(m,options)

t = m.tzero;
n = sum(m.nname(1:3));

shift = zeros([2,m.nname(2)]);
for i = 1 : m.nname(2)
  slice = m.occur(:,m.nname(1)+i,:);
  aux = vech(find(any(slice(m.ixeqtn{2},1,:),1))) - t;
  if ~isempty(aux)
    shift(1,i) = min([shift(1,i),aux]);
    shift(2,i) = max([shift(2,i),aux]);
    % evaluate farthest leads for nonlinear simulations
    % shift(2,i) = iff(shift(2,i) > 0 && m.linear == false,shift(2,i)+1,shift(2,i));
  end
  aux = vech(find(any(slice(m.ixeqtn{1},1,:),1))) - t;
  if ~isempty(aux)
    shift(1,i) = min([shift(1,i),min(aux)-1]);
  end
  if shift(1,i) == shift(2,i)
    shift(2,i) = 1;
  end
end

m.systemid{1} = m.ixname{1};
m.systemid{3} = m.ixname{3};
m.systemid{2} = zeros([1,0]);
Min = min(shift(1,1:end));
Max = max(shift(2,1:end));
for i = Max : -1 : Min 
  aux = find(i >= shift(1,1:end) & i < shift(2,1:end));
  m.systemid{2} = [m.systemid{2},complex(m.nname(1)+aux,i)];
end

nx = length(m.systemid{2});
nu = sum(imag(m.systemid{2}) >= 0);
np = nx - nu;

[m.metaderiv.y,m.metaderiv.uplus,m.metaderiv.u,m.metaderiv.pplus,m.metaderiv.p,m.metaderiv.e] = ...
  deal(zeros([1,0]));
[m.metasystem.y,m.metasystem.uplus,m.metasystem.u,m.metasystem.pplus,m.metasystem.p,m.metasystem.e] = ...
  deal(zeros([1,0]));

m.metaderiv.y = (t-1)*n + m.ixname{1};
m.metasystem.y = 1 : m.nname(1);

[m.systemident.xplus,m.systemident.x] = deal(zeros([0,nx]));

% delete double occurences
m.metadelete = false([1,nu]);
for i = 1 : nu
  if any(m.systemid{2}(i)-1i == m.systemid{2}(nu+1:end)), m.metadelete(i) = true; end
end

for i = 1 : nu
  id = m.systemid{2}(i);
  if imag(id) == shift(1,real(id)-m.nname(1))
    m.metaderiv.u(end+1) = (imag(id)+t-1)*n + real(id);
    m.metasystem.u(end+1) = i;
  end
  m.metaderiv.uplus(end+1) = (imag(id)+t+1-1)*n + real(id);
  m.metasystem.uplus(end+1) = i;
end

for i = 1 : np
  id = m.systemid{2}(nu+i);
  if imag(id) == shift(1,real(id)-m.nname(1))
    m.metaderiv.p(end+1) = (imag(id)+t-1)*n + real(id);
    m.metasystem.p(end+1) = i;
  end
  m.metaderiv.pplus(end+1) = (imag(id)+t+1-1)*n + real(id);
  m.metasystem.pplus(end+1) = i;  
end

m.metaderiv.e = (t-1)*n + m.ixname{3};
m.metasystem.e = 1 : m.nname(3);

for i = 1 : nu+np
  id = m.systemid{2}(i);
  if imag(id) ~= shift(1,real(id)-m.nname(1))
    aux = zeros([1,nu+np]);
    aux(m.systemid{2} == id-1i) = 1;
    m.systemident.xplus(end+1,1:end) = aux;
    aux = zeros([1,nu+np]);
    aux(i) = -1;
    m.systemident.x(end+1,1:end) = aux;
  end
end

end % of primary function -----------------------------------------------------------------------------------