function Omega = omega_(m,alt)
%
% MODEL/PRIVATE/OMEGA_  Covariance matrix of residuals.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

ne = sum(m.nametype == 3);
if nargin < 2, alt = 1 : size(m.assign,3);
  else alt = vech(alt); end

Omega = zeros([ne,ne,length(alt)]);
stdvec = m.assign(1,m.ixname{4}(end-m.nname(3)+1:end),alt);
for i = 1 : length(alt), Omega(:,:,i) = diag(stdvec(1,:,i).^2); end

end % of primary function -----------------------------------------------------------------------------------