function warning_(code,list,varargin)

if iswarning('model') == false, return, end

switch code

case 1
  msg = 'Variable name not found in model: ''%s''.';

case 2
  msg  = 'Parameter not available, NaN used instead: ''%s''.';

case 3
  msg = 'Steady state may not be accurate: %s.';

case 4
  msg = 'Log declarations disregarded in linear models.';
  
case 7
  msg = 'Invalid assignment of parameters.';
  
case 8
  msg = 'Time series not available for: ''%s''.';    
    
case 12
  msg = 'Parameter changed since last steady state and/or solution: ''%s''.';  
  
case 13
  msg = 'Unable to get growth rates for non-linear models.';  
    
case 14
  msg = 'Numerical instability. Status not reliable for: ''%s''.';

case 15
  msg = 'No anchored variable(s) or no free residual(s). Plain simulation run instead.';
  
case 18
  msg = '%sidentified anchoring system. (Data points exogenized: %g. Data points endogenized: %g.)';
      
case 19
  msg = 'Model solution expanded forward to t+%g.'; 
  
case 20
  msg = 'Model solution not available. Use SOLVE first.';

case 21
  msg = 'No effect of anticipated residuals (backward-looking model).';

case 22
  msg = 'Numerical inaccuracy of Schur decomposition. SEVN2 patch applied.';

case 23
  msg = 'Forward expansion already available up to t+%g.';

case 25
  msg = 'Unable to fix steady state: ''%s''.';
 
case 26 
  msg = 'Solution not available: No stable solution for parameterisation(s) No.%s.';

case 27
  msg = 'Solution not available: Multiple stable solutions for parameterisation(s) No.%s.';
 
case 28
  msg = 'Inappropriate choice of measurement variables: unable to estimate diffuse initial conditions.';

case 29
  msg = 'Solution not available: Complex derivatives in parameterisation(s) No.%s.';

case 30
  msg = 'Unable to evaluate @if expression, FALSE used instead: ''%s''.';  

case 31
  msg = 'Parameter name not found in model: ''%s''.';

case 32
  msg = 'Solution not available: State space singularity in parameterisation(s) No.%s.';
  
end

if nargin == 1, list = {}; end

printmsg('model','warning',msg,list,code);

end