function m = set(m,varargin)
%
% SET  Set attributes of model.
%
% Syntax:
%   m = set(m,<attrib,value>)
% Arguments:
%   value depends on attrib, m model, attrib char
% Attributes:
%   'nalt' numeric
%   'stdvec' numeric
%   'userdata' ?
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if ~iscellstr(varargin(1:2:end)), error('Incorrect type of input argument(s).'); end

% function body ---------------------------------------------------------------------------------------------

[ny,nx,nf,nb,ne,np,nalt] = dim_(m);
varargout = {};
unrecognized = {};

for i = 1 : 2 : length(varargin)
  attribute = strtrim(lower(varargin{i}));
  switch attribute
  case {'nalt'}
    m = nalt_(m,varargin{i+1});
  case {'stdvec'}
    m.assign(1,end-sum(m.nametype == 3)+1:end,:) = varargin{i+1};
  case 'userdata'
    m.userdata = varargin{i+1};
  otherwise
    unrecognized{end+1} = varargin{i};
  end
end

if ~isempty(unrecognized), error('Unrecognised attribute: ''%s''.\n',unrecognized{:}); end

end % of primary function -----------------------------------------------------------------------------------