function M = fmse(w,nper)
%
% FMSE  Forecast mean square error matrix for VAR variables.
%
% Syntax:
%   M = fmse(w,nper)
% Arguments:
%   M numeric; w rvar|svar; nper numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

[ny,p,nalt] = dim(w);
[T,R,K,Z,H,D,U,Omega] = sspace(w);
for ialt = 1 : nalt
  m = fmse(T(:,:,ialt),R(:,:,ialt),[],[],[],[],U,Omega(:,:,ialt),nper);
  M(:,:,:,ialt) = m(1:ny,1:ny,:);
end

end % of primary function -----------------------------------------------------------------------------------