function fprintf(w,fname,varargin)
%
% FPRINTF  Save SVAR as model code.
%
% Syntax:
%   fprintf(w,fname,...)
% Arguments:
%   w svar; fname char
% Options:
%   'decimal' numeric (empty)
%   'enames' cellstr (empty)
%   'format' char ('%+.16e')
%   'ynames' cellstr (empty)
%   'tolerance' numeric (getrealsmall())
% 
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

if isempty(w.B), error_(15); end

code = sprintf(w,varargin{:});
char2file(code,fname);

end % of primary function -----------------------------------------------------------------------------------