function flag = isstationary(w,varargin)
%
% ISSTATIONARY  True if all eigenvalues are less than 1 in modulus.
%
% Syntax:
%   flag = isstationary(w)
% Argument:
%   flag logical; w rvar|svar
% Options:
%   'tolerance' numeric (getrealsmall())
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

default = {...
  'tolerance',getrealsmall(),...
};
options = passopt(default,varargin{:});

% function body ---------------------------------------------------------------------------------------------

if isempty(w.TZ) || isempty(w.TZ{1}), w = schur_(w); end
[ny,p,nalt] = dim(w);
flag = false([1,nalt]);
for ialt = 1 : nalt, flag(ialt) = all(abs(w.eigval(1,:,ialt)) <= 1-options.tolerance); end

end % of primary function -----------------------------------------------------------------------------------