function ymean = mean(w,alt)
%
% MEAN  Unconditional mean of VAR process.
%
% Syntax:
%   ymean = mean(w)
%   ymean = mean(w,alt)
% Arguments:
%   ymean numeric; w rvar|svar; alt numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

[ny,p,nalt] = dim(w);

if p == 0,
  ymean = w.K;
  return
end

if nargin == 1, alt = 1 : nalt;
  else alt = vech(alt); end

[T,R,K,Z,H,D,U,Omega,w] = sspace(w);
realsmall = getrealsmall();
ymean = inf([ny,1,length(alt)]);
for ialt = alt
  nunit = sum(abs(abs(w.eigval(1,:,ialt)) - 1) <= realsmall);
  x = sum(var2poly(T(nunit+1:end,nunit+1:end,ialt)),3) \ K(nunit+1:end,1,ialt);
  index = ~isdiffuse(w.eigval(1,:,ialt),U(:,:,ialt));
  index(ny+1:end) = false;
  ymean(index,1,ialt) = U(index,nunit+1:end,ialt)*x;
end

end % of primary function -----------------------------------------------------------------------------------