function [RR,rr,nhyper] = restrict_(restrict,RR0,CC0,ny,nk,ng,order)
%
% RVAR/PRIVATE/RESTRICT_  Matrix representation of parameter restrictions.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

if iscell(restrict) && length(restrict) == 2 && isnumeric(restrict{1}) && isnumeric(restrict{2})
  RR = restrict{1};
  rr = restrict{2};
elseif ischar(restrict)
  if ~isempty(restrict)
    restrict = strrep(lower(restrict),' ','');
    patt = '=([^\];]*)';
    repl = '-\($1\)';
    restrict = regexprep(restrict,patt,repl);
    if restrict(1) ~= '[', restrict = ['[',restrict]; end
    if restrict(end) ~= ']', restrict = [restrict,']']; end
  end

  if ~isempty(restrict)
    [RR,rr] = read_(CC0,restrict,ny,nk,ng,order);
  elseif ~isempty(RR0)
    RR = RR0;
    rr = zeros([size(RR0,1),1]);
  else
    RR = [];
    rr = [];
  end
else
  RR = [];
  rr = [];
end

if isempty(RR), nhyper = order*ny+nk+ng;
  else nhyper = size(RR,2); end

end % of primary function -----------------------------------------------------------------------------------

  function [RR,rr] = read_(CC0,rstring,ny,nk,ng,order) % subfunction ----------------------------------------
  
  aux = reshape(transpose(1:ny*(ny*order+nk+ng)),[ny,ny*order+nk+ng]);
  aindex = reshape(aux(:,1:ny*order),[ny,ny,order]);
  aux(:,1:ny*order) = [];
  cindex = aux(:,1:nk);
  aux(:,1:nk) = [];
  gindex = aux;
  a = zeros(size(aindex));
  c = zeros(size(cindex));
  g = zeros(size(gindex));
  try, cc = vec(eval(rstring));
    catch, error_(1,{geterrormsg()}); end
  nrestrict = size(cc,1);
  CC = zeros([nrestrict,order*ny*ny+ny*nk]);
  for i = 1 : numel(c)
    c(i) = 1;
    CC(:,cindex(i)) = vec(eval(rstring)) - cc;
    c(i) = 0;
  end
  for i = 1 : numel(a)
    a(i) = 1;
    CC(:,aindex(i)) = vec(eval(rstring)) - cc;
    a(i) = 0;
  end
  for i = 1 : numel(g)
    g(i) = 1;
    CC(:,gindex(i)) = vec(eval(rstring)) - cc;
    g(i) = 0;
  end
  if ~isempty(CC0)
    CC = [CC;CC0];
    cc = [cc;zeros([size(CC0,1),1])];
  end
  RR = null(CC);
  rr = -pinv(CC)*cc;
  
  end % of subfunction --------------------------------------------------------------------------------------