function w = schur_(w) 
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

[ny,p,nalt] = dim(w);

if p == 0
  w.TZ{1} = zeros([ny,ny,nalt]);
  w.TZ{2} = eye(ny);
  w.TZ{2} = w.TZ{2}(:,:,ones([1,nalt]));
  w.eigval = zeros([1,ny,nalt]);
  return
end

realsmall = getrealsmall();
A = companion(w);
for ialt = 1 : nalt
  [Z,T] = schur(A(:,:,ialt));
  eigval = vech(ordeig(T));
  unstable = abs(eigval) > 1 + realsmall;
  unit = abs(abs(eigval) - 1) <= realsmall;
  stable = abs(eigval) < 1 - realsmall;
  clusters = zeros(size(eigval));
  clusters(unstable) = 2;
  clusters(unit) = 1;
  [Z,T] = ordschur(Z,T,clusters);
  w.TZ{1}(:,:,ialt) = T;
  w.TZ{2}(:,:,ialt) = Z;
  w.eigval(1,:,ialt) = vech(ordeig(T));
%  if any(unit), warning_(5,{sum(unit)}); end
%  if any(unstable), warning_(6,{sum(unstable)}); end
end

end % of primary function -----------------------------------------------------------------------------------