function w = transform(w,K)
%
% TRANSFORM  Linear transformation of the vector of VAR variables.
%
% Syntax:
%   w = transform(w,K)
% Arguments:
%   w rvar|svar; K numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

[ny,p,nalt] = dim(w);
for ialt = 1 : nalt
  A = reshape(w.A(:,:,ialt),[ny,ny,p]);
  for i = 1 : p, A(:,:,i) = K*A(:,:,i)/K; end
  w.A(:,:,ialt) = reshape(A,[ny,ny*p]);
  w.Omega(:,:,ialt) = K*w.Omega(:,:,ialt)*transpose(K);
  if ~isempty(w.B), w.B(:,:,ialt) = K*w.B(:,:,ialt); end
end

end % of primary function -----------------------------------------------------------------------------------