function x = fill(x,dates,data)
%
% FILL  Fill time series.
%
% x = fill(x,dates,data)
% Arguments:
%   x tseries; dates numeric; data numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if ~isnumeric(dates) || (~isnumeric(data) && ~isa(data,'logical')), error('Incorrect type of input argument(s).'); end

% function body ---------------------------------------------------------------------------------------------

dates = setdates(dates);

if isempty(data)
  data = NaN;
elseif length(data) > 1
  if isscalar(x), data = data(:); end
  [data,dim] = reshape_(data);
  data(end+(1:length(dates)-length(data)),:) = data(end,:);
  data = reshape_(data,dim);
end  

x = setdata_(x,dates,data);

end % of primary function -----------------------------------------------------------------------------------