function x = moving(x,varargin)
%
% MOVING  Apply function to moving window.
%
% Syntax:
%   x = moving(x)
%   x = moving(x,range,...)
% Arguments:
%   x tseries
% Options:
%   'function' function_handle (@mean)
%   'window' numeric (-freq+1:0)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if nargin == 1
  range = Inf;
elseif (nargin > 1 && ischar(varargin{1}))
  range = Inf;
else
  range = setrange(varargin{1});
  varargin(1) = [];
end

default = {
  'window',-(datfreq(x.start)-1):0,...
  'function',@mean,...
};
options = passopt(default,varargin{1:end});

% function body ---------------------------------------------------------------------------------------------

if ~isinf1(range), x = resize(x,range); end
x = unop_(@moving,x,0,options.window,options.function);

end % of primary function -----------------------------------------------------------------------------------