function output = binop_(fn,a,b,varargin)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

if istseries(a) && istseries(b)
  [a.data,adim,anper] = reshape_(a.data);
  [b.data,bdim,bnper] = reshape_(b.data);
  if all(adim == 1) && ~all(bdim == 1) % first tseries scalar; second tseries non-scalar
    a.data = a.data(:,ones([1,prod(bdim)]));
  elseif ~all(adim == 1) && all(bdim == 1) % first tseries non-scalar; second tseries scalar
    b.data = b.data(:,ones([1,prod(adim)]));
  end
  range = union_(a.start,anper,b.start,bnper);
  output = a;
  output.data = fn(getdata_(a,range),getdata_(b,range),varargin{:});
  output.data = reshape_(output.data,adim);
  output.start = range(1);
  output.comment(:) = {''};
else
  if istseries(a)
    output = a;
    a = a.data;
  else
    output = b;
    b = b.data;
  end
  x = fn(a,b,varargin{:});
  if size(x,1) == size(output.data,1), output.data = x;
    else, output = x; end
end

if istseries(output), output = cut_(output); end

end % of primary function -----------------------------------------------------------------------------------