function outputs = catcheck_(varargin)
%
% TSERIES/PRIVATE/CATCHECK_  Concatenation check.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

% non-tseries inputs
try, nontseries = ~cellfun(@istseries,varargin);
  catch, nontseries = ~cellfun('isclass',varargin,'tseries');
end
% remove non-tseries inputs w warning
if any(nontseries)
  warning('Data types other than tseries removed from concatenation.');
  varargin(nontseries) = [];
end

% check frequencies
freq = zeros(size(varargin));
for i = 1 : length(freq), freq(i) = datfreq(varargin{i}.start); end
nanindex = isnan(freq);
%freq(isnan(freq)) = [];
if sum(~nanindex) > 1 && any(diff(freq(~nanindex)) ~= 0)
  error('Unable to splice tseries with different frequencies.');
elseif all(nanindex)
  freq(:) = 0;
else
  freq(nanindex) = freq(find(~nanindex,1));
end

outputs = varargin;

end % of primary function -----------------------------------------------------------------------------------