function [data,dates] = getdata_(x,dates,varargin)

% function body ---------------------------------------------------------------------------------------------

dates = dates(:);
if any(isinf(dates))
  if nargin > 2, data = x.data(:,varargin{:});
    else data = x.data; end
  dates = x.start + (0 : size(x.data,1)-1);
elseif isempty(dates)
  dim = size(x.data);
  data = zeros([0,dim(2:end)]);
else
  if nargin > 2, [tmp,dim] = reshape_(x.data(:,varargin{:}));
    else [tmp,dim] = reshape_(x.data); end
  data = nan([length(dates),dim]);
  if ~isempty(tmp)
    index = round(dates - x.start + 1);
    freqtest = abs((dates-floor(dates)) - (x.start-floor(x.start))) < 1e-2;
    pos = find(index >= 1 & index <= size(x.data,1) & freqtest);
    data(pos,:) = tmp(index(pos),:);
  end
  data = reshape_(data,dim);
end
if issingle(x.data), data = single(data); end

end % of primary function -----------------------------------------------------------------------------------