function x = reshape(x,dim)
%
% RESHAPE  Change size of each element of time series.
%
% Syntax:
%   x = reshape(x)
%   x = reshape(x,size)
% Arguments:
%   x tseries; size numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

if nargin < 2
  dim = size(x.data);
  dim = prod(dim(2:end));
else
  if dim(1) ~= size(x.data,1), error('To RESHAPE time series the first input dimension must match the number of periods.'); end
  dim = dim(2:end);
end
x.data = reshape(x.data,[size(x.data,1),dim]);
x.comment = reshape(x.comment,[1,dim]);

end % of primary function -----------------------------------------------------------------------------------