function x = resize(x,range)
%
% RESIZE  Change time series range.
% 
% Syntax:
%   x = resize(x,range)
% Arguments:
%   x tseries; range numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if ~isnumeric(range), error('Incorrect type of input argument(s).'); end

% function body ---------------------------------------------------------------------------------------------

if isempty(range) || isnan(x.start)
  x = empty(x);
  return
elseif isinf1(range)
  return
end

xrange = get(x,'range');
startdate = iff(isinf(range(1)),xrange(1),range(1));
enddate = iff(isinf(range(end)),xrange(end),range(end));

range = startdate : enddate;
data = getdata_(x,range);
[x.start,x.data] = init_(range,data);
x = cut_(x);

end % of primary function -----------------------------------------------------------------------------------