function [year,per,freq] = dat2ypf(dat)
%
% DAT2YPF  Date to year-period-frequency vector conversion.
%
% Syntax:
%   [y,p,f] = dat2ypf(dat)
% Arguments:
%   y,p,f: numeric; dat: numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

yp = floor(dat);
freq = round(100*(dat - yp));
index = freq == 0;

[year,per] = deal(nan(size(dat)));

per(index) = dat(index); % indeterminate frequency
year(~index)  = floor(yp(~index) ./ freq(~index));
per(~index) = round(yp(~index) - year(~index).*freq(~index) + 1);

end % of primary function -----------------------------------------------------------------------------------