function varargout = dbevalt(d,range,varargin)
%
% DBEVAL  Evaluate expressions within database period by period.
%
% Syntax:
%   [<value>] = dbeval(d,<expr>)
% Arguments:
%   value ?; d struct; expr char
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if ~isstruct(d) || ~iscellstr(varargin)
  error('Incorrect type of input argument(s).');
end

% function body ---------------------------------------------------------------------------------------------

list = vech(fieldnames(d));
list(strmatch('IRIS_',list)) = [];
for i = 1 : length(list)
  varargin = regexprep(varargin,['(?<![\.@])(\<',list{i},'\>)'],'?.$1');
end
varargin = strrep(varargin,'?.','d.');
varargin = strrep(varargin,'@','');
for i = 1 : length(varargin)
  varargout{i} = eval(varargin{i},'NaN');
end

end % of primary function -----------------------------------------------------------------------------------