function d = mat2db(d,mat,range,name,shift,comment,include)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

nname = length(name);
nper = length(range);
nalt = size(mat,3);

if nargin < 6, include = false; end
if nargin < 7, comment(1:nname) = {''}; end

if isempty(mat), return, end

% disregard leads
index = shift > 0;
name(index) = [];
shift(index) = [];
comment(index) = [];
mat(index,:,:) = [];

minshift = -min(shift);
range = range(1)-minshift:range(end);
t = minshift + (1:nper);
X = nan(0,class(mat));
x = nan([1,nper + minshift,nalt],class(mat));
name_ = {};
comment_ = {};
name0 = name;

remain = 1 : size(mat,1);
while ~isempty(name)
  name_{end+1} = name{1};
  comment_{end+1} = comment{1};
  index = strcmp(name{1},name);
  x(:) = NaN;
  if include == true, for i = vech(find(index)), x(1,t+shift(i),:) = mat(remain(i),:,:); end
    else, x(1,t,:) = mat(remain(index & shift == 0),:,:); end
  X = [X;x];
  name(index) = [];
  shift(index) = [];
  comment(index) = [];
  %mat(index,:,:) = [];
  remain(index) = [];
end

nx = size(X,1);
value = cell(size(name_));
for i = 1 : nx
  value{i} = tseries(range,permute(X(i,:,:),[2,3,1]),comment_{i});
end

d = dbmerge(d,name_,value);

end % of primary function -----------------------------------------------------------------------------------