function d = dp2dbase(dpack,varargin)
%
% DP2DBASE  Datapack to database conversion.
%
% Syntax:
%   d = dp2dbase(dpack,...)
% Arguments:
%   d struct; dpack cell
% Options:
%   'merge' struct (empty)
%   'include' logical (false)
%   'output' 'dbase'|'struct' ('dbase')
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

default = {...
  'merge',struct(),...
  'include',false,...
};
options = passopt(default,varargin{:});

% function body ---------------------------------------------------------------------------------------------

me = dpack{5};
id = [me.id{:}];
mat = [dpack{1};dpack{2};dpack{3}];
mat(me.log(real(id)),:,:) = exp(mat(me.log(real(id)),:,:));
d = mat2db(options.merge,mat,dpack{4},me.name(real(id)),imag(id),me.namelabel(real(id)),options.include);

end % of primary function -----------------------------------------------------------------------------------