function dpack = dpresize(dpack,range)
%
% DPRESIZE  Change range of datapack.
%
% Syntax:
%   dpack = dpresize(dpack,range);
% Arguments:
%   dpack cell; range numeric
%
% The IRIS Toolbox 2006/10/02. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

oldrange = dpack{4};
if isinf1(range), return, end
if length(range) == 2
  if isinf(range(1)), range(1) = oldrange(1); end
  if isinf(range(2)), range(2) = oldrange(end); end
end
newrange = range(1) : range(end);
if rngcmp(newrange,oldrange), return, end

index = round(newrange - oldrange(1)) + 1;
npre = sum(index < 1);
npost = sum(index > length(oldrange));
index = index(index >= 1 & index <= length(oldrange));
for i = 1 : 3
  precision = class(dpack{i});
  n1 = size(dpack{i},1);
  n3 = size(dpack{i},3);
  dpack{i} = [...
    nan([n1,npre,n3],precision),...
    dpack{i}(:,index,:),...
    nan([n1,npost,n3],precision),...
  ];
end
dpack{4} = newrange;

end % of primary function -----------------------------------------------------------------------------------