function Sd = xsf2sdf(S,C)
%
% TIME-DOMAIN/COV2CORR Power spectrum to spectral density conversion.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

Sd = S;
realsmall = getrealsmall();
nalt = size(S,4);

for ialt = 1 : nalt
  Sdk = S(:,:,:,ialt);
  aux = diag(C(:,:,1,ialt));
  nonzero = abs(aux) > realsmall;
  aux(nonzero) = 1./sqrt(aux(nonzero));
  D = aux(:,ones([1,size(aux,1)]));
  D = D.*transpose(D);
  index = isinf(Sdk(:,:,:));
  Sdk(index) = 0;
  for i = 1 : size(Sdk,3), Sdk(:,:,i) = D.*Sdk(:,:,i); end
  Sdk(index) = NaN;
  Sd(:,:,:,ialt) = Sdk;
end

end % of primary function -----------------------------------------------------------------------------------