function C = acovfyw(A,C,order)
%
% TIME-DOMAIN/ACOVFYW  VAR autocovariance function for higher orders based on Yule-Walker equations.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

[ny,aux] = size(A);
p = aux/ny;

A = reshape(A(:,1:ny*p),[ny,ny,p]);
C = C(:,:,1+(0:p-1));
for i = p : order
  aux = zeros(ny);
  for j = 1 : size(A,3)
    aux = aux + A(:,:,j)*C(:,:,end-j+1);
  end
  C(:,:,1+i) = aux;
end

end % of primary function -----------------------------------------------------------------------------------