function h = ploteig(x,flag,varargin)
%
% PLOTEIG  Plot eigenvalues.
% 
% h = ploteig(x,ucircle...)
% Arguments:
%   h numeric; x model|rvar|svar; ucircle logical
% Options:
%   any Matlab plot options
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if nargin < 2, flag = true; end

plotspec = {'marker','x','linestyle','none'};
plotspec = [plotspec,varargin];

% function body ---------------------------------------------------------------------------------------------

set(0,'defaultlinemarkersize',8,'defaultlinelinewidth',1);
eigval = eig(x);
h = plot(real(eigval),imag(eigval),plotspec{:});
if flag == true
  nextplot = get(gca,'nextplot');
  set(gca,'nextplot','add');
  h(2,1) = ucircle(varargin{:});
  set(gca,'nextplot',nextplot);
end

end % of primary function -----------------------------------------------------------------------------------