function x = moving(x,window,fn)
%
% MOVING  Moving function applied to windowed vectors.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

window = vech(window);
if isempty(window)
  warning('Empty moving window.');
  x(:) = NaN;
else
  for i = 1 : size(x,2), x(:,i) = feval(fn,shift(x(:,i),window),2); end
end

end % of primary function -----------------------------------------------------------------------------------