function x = stdize(x,flag)
%
% STDIZE  Subtract mean and divide by std deviation columwise.
%
% Syntax:
%   x = stdize(x)
%   x = stdize(x,flag)
% Arguments:
%   x numeric; flag numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if nargin < 2, flag = 0; end

% function body ---------------------------------------------------------------------------------------------

dim = size(x);
x = reshape(x,[dim(1),prod(dim(2:end))]);
for i = 1 : size(x,2)
  sample = ~isnan(x(:,i));
  nper = sum(sample) - iff(flag == 0,1,0);
  x(:,i) = x(:,i) - mean(x(sample,i));
  x(:,i) = x(:,i) / sqrt(transpose(x(sample,i))*x(sample,i)/nper);
end
x = reshape(x,dim);

end % of primary function -----------------------------------------------------------------------------------