function [C,R] = acf(y,varargin)
%
% ACF  Sample covariance and correlation function.
%
% [C,R] = acf(x,...)
% Arguments:
%   C numeric; R numeric; x numeric
% Options:
%   'order' numeric (0)
%   'smallsample' logical (true)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

sample = getsample(permute(y,[2,1,3]));
y = y(sample,:,:);
nalt = size(y,3);
for ialt = 1 : nalt
  C(:,:,:,ialt) = acovfsmp(y(:,:,ialt),varargin{:});
  if nargout > 1, R(:,:,:,ialt) = cov2corr(C(:,:,:,ialt)); end
end

end % of primary function -----------------------------------------------------------------------------------