function [index,notfound] = findnames(list,selection)
%
% FINDNAMES  Positions of selected names in list.
%
% Syntax:
%   [index,notfound] = findnames(list,selection)
% Arguments:
%   index numeric, notfound cellstr, list cellstr, selection cellstr|char
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if (~iscellstr(list) && ~ischar(list)) || (~iscellstr(selection) && ~ischar(selection))
  error('Incorrect type of input argument(s).');
end

if ischar(selection), selection = {selection}; end

% function body ---------------------------------------------------------------------------------------------

index = nan(size(selection));
for i = 1 : length(selection(:))
  tmp = strcmp(list,selection{i});
  if any(tmp), index(i) = find(tmp,1); end
end
notfound = vech(selection(isnan(index)));

end % of primary function -----------------------------------------------------------------------------------