function x = loadstruct(fname)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

% keywords are loaded with an underscore
list = vech(who('-file',fname));
index = cellfun(@iskeyword,list);
if any(index)
  x = load('-mat',fname,list{~index});
  warning off;
  for i = find(index)
    xx = load('-mat',fname,list{i});
    xx = struct2cell(xx);
    x.(list{i}) = xx{1};
  end
  warning on;
else
  x = load('-mat',fname);
end

try
  if x.IRIS_MODEL == true
    x = model(x);
    return
  end
catch, end
try
  if x.IRIS_VAR == true
    x = rvar(x);
    return
  end
catch, end
try
  if x.IRIS_DATAPACK == true
    tmp = {};
    for i = 1 : 5, tmp{i} = x.cell{i}; end
    x = tmp;
  end
catch, end

end % of primary function -----------------------------------------------------------------------------------