function [match,index,tokens] = query(list,pattern)
%
% QUERY  Names from list or database to match desired pattern.
%
% Syntax:
%   [match,index,tokens] = query(d,pattern)
%   [match,index,tokens] = query(list,pattern)
% Arguments:
%   match cellstr; index logical; tokens cell; d struct; list cellstr; pattern char
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if isstruct(list), list = vech(fieldnames(list)); end
if ~iscellstr(list) || ~ischar(pattern), error('Incorrect type of input argument(s).'); end

% function body ---------------------------------------------------------------------------------------------\

tokens = cell([1,0]);
[match,tokens] = regexp(list,pattern,'match','tokens','once');
index = strcmp(match,list);
match = match(index);
tokens = tokens(index);

end % of primary function -----------------------------------------------------------------------------------