function setdatetick(handle,freq,dateformat,datetick)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if nargin < 3 || isempty(dateformat)
  config = load('irisconfig.mat');
  dateformat = config.plotdateformat;
end
if nargin < 4, datetick = Inf; end

% function body ---------------------------------------------------------------------------------------------

for i = 1 : length(handle(:))
  xtick = get(handle(i),'xtick');
  xlim = get(handle(i),'xlim');
  if ~isnan(freq)
    if freq > 0 && any(isinf(datetick))
      multiple = max([round((xtick(2)-xtick(1)) * freq),1]);
      set(handle(i),'xtick',(xlim(1):multiple/freq:xlim(2)));	
    elseif ~any(isinf(datetick))
      set(handle(i),'xtickmode','manual','xtick',dat2dec(datetick));
      set(handle(i),'xlimmode','manual','xlim',dat2dec(datetick([1,end])));
    end
    range = dec2dat(transpose(get(handle(i),'xtick')),freq);
    set(handle(i),'xticklabelmode','manual');
    set(handle(i),'xticklabel',char(dat2str(range,dateformat)));
    set(handle(i),'xtickmode','manual');
  else
    set(handle(i),'xtick',xlim);
    set(handle(i),'xticklabel',strvcat('NaN','NaN'));
  end
end

end % of primary function -----------------------------------------------------------------------------------