function [P,Q] = theil(p,q,range)
%
% THEIL  Tornqvist-Theil index number.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

if nargin > 2
  p = resize(p,range);
  q = resize(q,range);
end

w = [];
pq = p.*q;
PQ = sum(pq,2);
w = pq./PQ;
dlogp = diff(log(p));
dlogq = diff(log(q));
dlogP = sum(w.*dlogp,2);
dlogQ = sum(w.*dlogq,2);

start = get(dlogP,'start');
dlogP(start-1) = 1;
P = exp(cumsum(dlogP));
Q = PQ./P;

end % of primary function -----------------------------------------------------------------------------------